/*
 *   Copyright 2009 Johan Thelin <e8johan@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2 or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
#include "randomnumberengine.h"

#include <QDateTime>

RandomNumberEngine::RandomNumberEngine( QObject *parent, const QVariantList &args )
    : Plasma::DataEngine( parent, args )
{
}

QStringList RandomNumberEngine::sources() const
{
    return QStringList() << "Number";
}

bool RandomNumberEngine::sourceRequestEvent( const QString &name )
{
    if( name != "Number" )
        return false;

    qsrand( QDateTime::currentDateTime().toTime_t() );
    return updateSourceEvent( name );
}

bool RandomNumberEngine::updateSourceEvent( const QString &name )
{
    if( name != "Number" )
        return false;

    setData( name, qrand() );
    return true;
}

K_EXPORT_PLASMA_DATAENGINE(randomnumber, RandomNumberEngine)

#include "randomnumberengine.moc"
